package xyz.brassgoggledcoders.moarcarts.entities;

import net.minecraft.block.BlockRailBase;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.Entity;
import net.minecraft.entity.projectile.EntityArrow;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.BlockPos;
import net.minecraft.util.DamageSource;
import net.minecraft.util.EnumParticleTypes;
import net.minecraft.world.Explosion;
import net.minecraft.world.World;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

public abstract class EntityMinecartExplosiveBase extends EntityMinecartBase
{
    private int minecartTNTFuse = -1;

    public EntityMinecartExplosiveBase(World world, int metadata)
    {
        super(world, metadata);
    }

    /**
     * Called to update the entity's position/logic.
     */
    public void func_70071_h_()
    {
        super.func_70071_h_();

        if (this.minecartTNTFuse > 0)
        {
            --this.minecartTNTFuse;
            this.field_70170_p.func_175688_a(EnumParticleTypes.SMOKE_NORMAL, this.field_70165_t, this.field_70163_u + 0.5D, this.field_70161_v, 0.0D, 0.0D, 0.0D, new int[0]);
        }
        else if (this.minecartTNTFuse == 0)
        {
            this.explodeCart(this.field_70159_w * this.field_70159_w + this.field_70179_y * this.field_70179_y);
        }

        if (this.field_70123_F)
        {
            double d0 = this.field_70159_w * this.field_70159_w + this.field_70179_y * this.field_70179_y;

            if (d0 >= 0.009999999776482582D)
            {
                this.explodeCart(d0);
            }
        }
    }

    @Override
    public boolean func_70097_a(DamageSource source, float amount)
    {
        Entity entity = source.func_76364_f();

        if (entity instanceof EntityArrow)
        {
            EntityArrow entityarrow = (EntityArrow)entity;

            if (entityarrow.func_70027_ad())
            {
                this.explodeCart(entityarrow.field_70159_w * entityarrow.field_70159_w + entityarrow.field_70181_x * entityarrow.field_70181_x + entityarrow.field_70179_y * entityarrow.field_70179_y);
            }
        }

        return super.func_70097_a(source, amount);
    }

    @Override
    public void func_94095_a(DamageSource source)
    {
        super.func_94095_a(source);
        double d0 = this.field_70159_w * this.field_70159_w + this.field_70179_y * this.field_70179_y;

        //TODO Actually respect doEntityDrops
        if (!source.func_94541_c() && this.field_70170_p.func_82736_K().func_82766_b("doEntityDrops"))
        {
            super.dropCart();
        }

        if (source.func_76347_k() || source.func_94541_c() || d0 >= 0.009999999776482582D)
        {
            this.explodeCart(d0);
        }
    }

    @Override
    public void dropCart()
    {
        //Need the source. So here do nothing.
    }

    protected void explodeCart(double p_94103_1_)
    {
        if (!this.field_70170_p.field_72995_K)
        {
            double d0 = Math.sqrt(p_94103_1_);

            if (d0 > 5.0D)
            {
                d0 = 5.0D;
            }

            this.field_70170_p.func_72876_a(this, this.field_70165_t, this.field_70163_u, this.field_70161_v, (float)(4.0D + this.field_70146_Z.nextDouble() * 1.5D * d0), true);
            this.func_70106_y();
        }
    }

    @Override
    public void func_180430_e(float distance, float damageMultiplier)
    {
        if (distance >= 3.0F)
        {
            float f = distance / 10.0F;
            this.explodeCart((double)(f * f));
        }

        super.func_180430_e(distance, damageMultiplier);
    }

    @Override
    public void func_96095_a(int x, int y, int z, boolean receivingPower)
    {
        if (receivingPower && this.minecartTNTFuse < 0)
        {
            this.ignite();
        }
    }

    @Override
    @SideOnly(Side.CLIENT)
    public void func_70103_a(byte id)
    {
        if (id == 10)
        {
            this.ignite();
        }
        else
        {
            super.func_70103_a(id);
        }
    }

    public void ignite()
    {
        this.minecartTNTFuse = 80;

        if (!this.field_70170_p.field_72995_K)
        {
            this.field_70170_p.func_72960_a(this, (byte)10);

            if (!this.func_174814_R())
            {
                this.field_70170_p.func_72956_a(this, "game.tnt.primed", 1.0F, 1.0F);
            }
        }
    }

    public int getFuseTicks()
    {
        return this.minecartTNTFuse;
    }

    public boolean isIgnited()
    {
        return this.minecartTNTFuse > -1;
    }

    @Override
    public float func_180428_a(Explosion explosionIn, World worldIn, BlockPos pos, IBlockState blockStateIn)
    {
        return !this.isIgnited() || !BlockRailBase.func_176563_d(blockStateIn) && !BlockRailBase.func_176562_d(worldIn, pos.func_177984_a())
                ? super.func_180428_a(explosionIn, worldIn, pos, blockStateIn) : 0.0F;
    }

    @Override
    public boolean func_174816_a(Explosion explosionIn, World worldIn, BlockPos pos, IBlockState blockStateIn, float p_174816_5_)
    {
        return !this.isIgnited() || !BlockRailBase.func_176563_d(blockStateIn) && !BlockRailBase.func_176562_d(worldIn, pos.func_177984_a())
                && super.func_174816_a(explosionIn, worldIn, pos, blockStateIn, p_174816_5_);
    }

    @Override
    protected void func_70037_a(NBTTagCompound tagCompund)
    {
        super.func_70037_a(tagCompund);

        if (tagCompund.func_150297_b("TNTFuse", 99))
        {
            this.minecartTNTFuse = tagCompund.func_74762_e("TNTFuse");
        }
    }

    @Override
    protected void func_70014_b(NBTTagCompound tagCompound)
    {
        super.func_70014_b(tagCompound);
        tagCompound.func_74768_a("TNTFuse", this.minecartTNTFuse);
    }
}
