package xyz.brassgoggledcoders.moarcarts.entities;

import mods.railcraft.api.carts.IItemCart;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.entity.item.EntityMinecart;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.EnumFacing;
import net.minecraft.world.World;
import net.minecraftforge.fml.common.Optional;
import net.minecraftforge.items.CapabilityItemHandler;
import net.minecraftforge.items.IItemHandler;
import xyz.brassgoggledcoders.boilerplate.lib.common.utils.ComparatorUtils;

/**
 * @author SkySom
 * TODO: Railcraft - IItemcart
 */
@Optional.Interface(iface = "mods.railcraft.api.carts.IItemCart", modid = "RailcraftAPI|carts")
public abstract class EntityMinecartInventoryTEBase extends EntityMinecartCapableTEBase implements IItemCart
{
	private boolean dropContentsWhenDead = true;

	public EntityMinecartInventoryTEBase(World world, int metadata)
	{
		super(world, metadata);
	}

	@Override
	public void func_70106_y()
	{
		if (this.dropContentsWhenDead() && !this.shouldSaveDataToItem())
		{
			IItemHandler itemHandler = getItemHandler();
			if(itemHandler != null)
			{
				for (int i = 0; i < itemHandler.getSlots(); ++i)
				{
					ItemStack itemstack = itemHandler.getStackInSlot(i);

					if (itemstack != null)
					{
						float f = this.field_70146_Z.nextFloat() * 0.8F + 0.1F;
						float f1 = this.field_70146_Z.nextFloat() * 0.8F + 0.1F;
						float f2 = this.field_70146_Z.nextFloat() * 0.8F + 0.1F;

						while (itemstack.field_77994_a > 0)
						{
							int j = this.field_70146_Z.nextInt(21) + 10;

							if (j > itemstack.field_77994_a)
							{
								j = itemstack.field_77994_a;
							}

							itemstack.field_77994_a -= j;
							EntityItem entityitem = new EntityItem(this.field_70170_p, this.field_70165_t + (double)f, this.field_70163_u + (double)f1, this.field_70161_v + (double)f2, new ItemStack(itemstack.func_77973_b(), j, itemstack.func_77952_i()));

							if (itemstack.func_77942_o())
							{
								entityitem.func_92059_d().func_77982_d((NBTTagCompound)itemstack.func_77978_p().func_74737_b());
							}

							float f3 = 0.05F;
							entityitem.field_70159_w = (double)((float)this.field_70146_Z.nextGaussian() * f3);
							entityitem.field_70181_x = (double)((float)this.field_70146_Z.nextGaussian() * f3 + 0.2F);
							entityitem.field_70179_y = (double)((float)this.field_70146_Z.nextGaussian() * f3);
							if(!field_70170_p.field_72995_K)
							{
								this.field_70170_p.func_72838_d(entityitem);
							}
						}
					}
				}
			}
		}

		super.func_70106_y();
	}

	@Override
	public void func_71027_c(int dimension)
	{
		this.setDropContentsWhenDead(false);
		super.func_71027_c(dimension);
	}

	public IItemHandler getItemHandler()
	{
		if(hasCapability(CapabilityItemHandler.ITEM_HANDLER_CAPABILITY, EnumFacing.UP))
		{
			return getCapability(CapabilityItemHandler.ITEM_HANDLER_CAPABILITY, EnumFacing.UP);
		}
		return null;
	}

	public int getComparatorInputOverride()
	{
		if(!this.getCartBlock().func_149740_M())
		{
			return ComparatorUtils.scaleIItemHandlerLevelTo(15, getCapability(
					CapabilityItemHandler.ITEM_HANDLER_CAPABILITY, null));
		}
		return super.getComparatorInputOverride();
	}

	@Override
	public boolean isUseableByPlayer(EntityPlayer entityPlayer)
	{
		return entityPlayer.func_70011_f(this.field_70165_t, this.field_70163_u, this.field_70161_v) <= 64D;
	}

	@Override
	public boolean canPassItemRequests()
	{
		return true;
	}

	@Override
	public boolean canAcceptPushedItem(EntityMinecart entityMinecart, ItemStack itemStack)
	{
		return true;
	}

	@Override
	public boolean canProvidePulledItem(EntityMinecart entityMinecart, ItemStack itemStack)
	{
		return true;
	}

	public boolean dropContentsWhenDead()
	{
		return dropContentsWhenDead;
	}

	public void setDropContentsWhenDead(boolean drop)
	{
		this.dropContentsWhenDead = drop;
	}
}
