package xyz.brassgoggledcoders.moarcarts.fakeworld;

import net.minecraft.block.Block;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.Entity;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.AxisAlignedBB;
import net.minecraft.util.BlockPos;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumParticleTypes;
import net.minecraft.world.Explosion;
import net.minecraft.world.World;
import net.minecraft.world.chunk.Chunk;
import net.minecraft.world.chunk.IChunkProvider;
import xyz.brassgoggledcoders.moarcarts.entities.EntityMinecartBase;
import xyz.brassgoggledcoders.moarcarts.entities.EntityMinecartTEBase;

import java.util.List;

/**
 * @author SkySom
 */
public class FakeWorld extends World
{
	private EntityMinecartTEBase entityMinecartTEBase;
	private EntityMinecartBase entityMinecartBase;

	public FakeWorld(EntityMinecartBase entityMinecartBase)
	{
		this(entityMinecartBase.field_70170_p, entityMinecartBase);
	}

	public FakeWorld(World world, EntityMinecartBase entityMinecartBase)
	{
		super(world.func_72860_G(), world.func_72912_H(), world.field_73011_w, world.field_72984_F, world.field_72995_K);
		this.setEntityMinecartBase(entityMinecartBase);
		if(entityMinecartBase instanceof EntityMinecartTEBase)
		{
			this.setEntityMinecartTEBase((EntityMinecartTEBase)entityMinecartBase);
		}
	}

	//MFR grabs TE's just a bit different than most
	@Override
	protected IChunkProvider func_72970_h()
	{
		return field_73020_y;
	}

	//Pretty sure this for IE's blocks originally though other use it.
	@Override
	public void func_175689_h(BlockPos blockPos)
	{
		if(this.getEntityMinecartTEBase() != null)
		{
			this.getEntityMinecartTEBase().setDirty(true);
		}
	}

	//Enderchest use this for open and close
	@Override
	public void func_175641_c(BlockPos blockPos, Block block, int metadata, int p_14745) {}

	@Override
	public boolean isSideSolid(BlockPos blockPos, EnumFacing blockSide)
	{
		return false;
	}

	@Override
	public TileEntity func_175625_s(BlockPos blockPos)
	{
		if(blockPos.equals(this.getEntityMinecartBase().ORIGIN_POS)) {
			if(this.getEntityMinecartTEBase() != null)
			{
				return this.getEntityMinecartTEBase().getTileEntity();
			}
		}
		return null;
	}

	//Really hope this doesn't break anything. Welp.
	@Override
	protected int func_152379_p()
	{
		return 0;
	}

	@Override
	public Entity func_73045_a(int id)
	{
		return this.getEntityMinecartBase().field_70170_p.func_73045_a(id);
	}

	//Most Blocks use this.
	@Override
	public IBlockState func_180495_p(BlockPos blockPos)
	{
		if(blockPos.equals(this.getEntityMinecartBase().ORIGIN_POS)) {
			return this.getEntityMinecartBase().func_174897_t();
		}
		return this.getEntityMinecartBase().func_180457_u();
	}

	//Enderchest Particles
	@Override
	public void func_175688_a(EnumParticleTypes enumParticleType, double posX, double posY, double posZ, double velX,
			double velY, double velZ, int... what)
	{
		int intCartX = (int)Math.floor(this.getCartX());
		int intCartY = (int)Math.floor(this.getCartY());
		int intCartZ = (int)Math.floor(this.getCartZ());
		double changeInX = (this.getCartX() - (double)intCartX) / 2.0;
		double changeInY = (this.getCartY() - (double)intCartY) / 2.0;
		double changeInZ = (this.getCartZ() - (double)intCartZ) / 2.0;
		this.getCartWorld().func_175688_a(enumParticleType, posX - changeInX, posY - changeInY, posZ - changeInZ,
				velX, velY, velZ);
	}

	//Infinitato tries to get Entities and add potion effects
	@Override
	public <T extends Entity> List<T> func_72872_a(Class<? extends T > entityClass, AxisAlignedBB axisAlignedBB)
	{
		axisAlignedBB.func_72320_b();

		return this.getCartWorld().func_72872_a(entityClass, axisAlignedBB);
	}

	//Infinitato creates explosions when it lands
	@Override
	public Explosion func_72876_a(Entity entity, double posX, double posY, double posZ, float size, boolean damage)
	{
		return this.getCartWorld().func_72876_a(entity, this.getCartX(), this.getCartY(), this.getCartZ(), size, damage);
	}

	//Shia Labouef tiny potato screams "Just do it"
	@Override
	public void func_72908_a(double posX, double posY, double posZ, String sound, float noice, float soundTimes)
	{
		this.getCartWorld().func_72956_a(this.getEntityMinecartBase(), sound, noice, soundTimes);
	}

	@Override
	public Chunk func_72964_e(int chunkX, int chunkZ)
	{
		return this.getCartWorld().func_72964_e(chunkX, chunkZ);
	}

	@Override
	protected boolean func_175680_a(int x, int z, boolean allowEmpty)
	{
		return true;
	}

	@Override
	public void func_175646_b(BlockPos pos, TileEntity unusedTileEntity)
	{
		if(this.getEntityMinecartTEBase() != null)
		{
			this.getEntityMinecartTEBase().markDirty();
		}
	}

	public EntityMinecartTEBase getEntityMinecartTEBase()
	{
		if(entityMinecartTEBase == null && entityMinecartBase != null)
		{
			this.setEntityMinecartTEBase((EntityMinecartTEBase)entityMinecartBase);
		}
		return entityMinecartTEBase;
	}

	public void setEntityMinecartTEBase(EntityMinecartTEBase entityMinecartTEBase)
	{
		this.entityMinecartTEBase = entityMinecartTEBase;
	}

	public EntityMinecartBase getEntityMinecartBase()
	{
		if(entityMinecartBase == null && entityMinecartTEBase != null)
		{
				this.setEntityMinecartBase(entityMinecartTEBase);
		}
		return entityMinecartBase;
	}

	public void setEntityMinecartBase(EntityMinecartBase entityMinecartBase)
	{
		this.entityMinecartBase = entityMinecartBase;
	}

	public double getCartX()
	{
		return this.getEntityMinecartBase().field_70165_t;
	}

	public double getCartY()
	{
		return this.getEntityMinecartBase().field_70163_u;
	}

	public double getCartZ()
	{
		return this.getEntityMinecartBase().field_70161_v;
	}

	public World getCartWorld()
	{
		return this.getEntityMinecartBase().field_70170_p;
	}
}
