package xyz.brassgoggledcoders.moarcarts.mods.extras.block;

import net.minecraft.block.material.Material;
import net.minecraft.block.properties.PropertyBool;
import net.minecraft.block.properties.PropertyDirection;
import net.minecraft.block.state.BlockState;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.AxisAlignedBB;
import net.minecraft.util.BlockPos;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumWorldBlockLayer;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import xyz.brassgoggledcoders.boilerplate.lib.client.models.IHasModel;
import xyz.brassgoggledcoders.boilerplate.lib.common.blocks.BlockTEBase;
import xyz.brassgoggledcoders.boilerplate.lib.common.utils.Selectors;
import xyz.brassgoggledcoders.moarcarts.mods.extras.tiles.TileFluidHopper;

import java.util.List;

public class BlockFluidHopper extends BlockTEBase implements IHasModel
{
	public static final PropertyDirection FACING = PropertyDirection.func_177712_a("facing", Selectors.NOT_UP);
	public static final PropertyBool ENABLED = PropertyBool.func_177716_a("enabled");

	public BlockFluidHopper()
	{
		super(Material.field_151573_f, "fluid_hopper");
		this.func_180632_j(this.field_176227_L.func_177621_b().func_177226_a(FACING, EnumFacing.DOWN).func_177226_a(ENABLED, true));
		this.func_149676_a(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
	}

	@Override
	public void func_180654_a(IBlockAccess worldIn, BlockPos pos)
	{
		this.func_149676_a(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
	}

	@Override
	public void func_180638_a(World worldIn, BlockPos pos, IBlockState state, AxisAlignedBB mask, List<AxisAlignedBB> list, Entity collidingEntity)
	{
		this.func_149676_a(0.0F, 0.0F, 0.0F, 1.0F, 0.625F, 1.0F);
		super.func_180638_a(worldIn, pos, state, mask, list, collidingEntity);
		float f = 0.125F;
		this.func_149676_a(0.0F, 0.0F, 0.0F, f, 1.0F, 1.0F);
		super.func_180638_a(worldIn, pos, state, mask, list, collidingEntity);
		this.func_149676_a(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, f);
		super.func_180638_a(worldIn, pos, state, mask, list, collidingEntity);
		this.func_149676_a(1.0F - f, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
		super.func_180638_a(worldIn, pos, state, mask, list, collidingEntity);
		this.func_149676_a(0.0F, 0.0F, 1.0F - f, 1.0F, 1.0F, 1.0F);
		super.func_180638_a(worldIn, pos, state, mask, list, collidingEntity);
		this.func_149676_a(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
	}

	@Override
	public IBlockState func_180642_a(World worldIn, BlockPos pos, EnumFacing facing, float hitX, float hitY, float hitZ, int meta, EntityLivingBase placer)
	{
		EnumFacing enumfacing = facing.func_176734_d();

		if (enumfacing == EnumFacing.UP)
		{
			enumfacing = EnumFacing.DOWN;
		}

		return this.func_176223_P().func_177226_a(FACING, enumfacing).func_177226_a(ENABLED, true);
	}

	@Override
	public boolean func_149686_d()
	{
		return false;
	}

	@Override
	public boolean func_149662_c()
	{
		return false;
	}

	@SideOnly(Side.CLIENT)
	@Override
	public boolean func_176225_a(IBlockAccess worldIn, BlockPos pos, EnumFacing side)
	{
		return true;
	}

	public static EnumFacing getFacing(int meta)
	{
		return EnumFacing.func_82600_a(meta & 7);
	}

	public static boolean isEnabled(int meta)
	{
		return (meta & 8) != 8;
	}

	@SideOnly(Side.CLIENT)
	public EnumWorldBlockLayer func_180664_k()
	{
		return EnumWorldBlockLayer.CUTOUT_MIPPED;
	}

	public IBlockState func_176203_a(int meta)
	{
		return this.func_176223_P().func_177226_a(FACING, getFacing(meta)).func_177226_a(ENABLED, isEnabled(meta));
	}

	public int func_176201_c(IBlockState state)
	{
		int i = 0;
		i = i | state.func_177229_b(FACING).func_176745_a();

		if (!state.func_177229_b(ENABLED))
		{
			i |= 8;
		}

		return i;
	}

	@Override
	protected BlockState func_180661_e()
	{
		return new BlockState(this, FACING, ENABLED);
	}

	@Override
	public Class<? extends TileEntity> getTileEntityClass()
	{
		return TileFluidHopper.class;
	}

	@Override
	public String[] getResourceLocations()
	{
		return new String[] {"fluid_hopper"};
	}
}
