package xyz.brassgoggledcoders.moarcarts.mods.tinkers.tiles;

import net.minecraft.entity.item.EntityMinecart;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.world.WorldServer;
import net.minecraftforge.fluids.FluidStack;
import net.minecraftforge.fluids.IFluidHandler;
import slimeknights.tconstruct.common.TinkerNetwork;
import slimeknights.tconstruct.smeltery.network.FaucetActivationPacket;
import slimeknights.tconstruct.smeltery.tileentity.TileFaucet;
import xyz.brassgoggledcoders.moarcarts.utils.Utils;

//Code Pulled up from TileFaucet and switched to carts for filling :D
public class TileCartFaucet extends TileFaucet
{
	@Override
	protected void doTransfer() {
		// still got content left
		if(drained != null) {
			return;
		}
		TileEntity drainTE = field_145850_b.func_175625_s(field_174879_c.func_177972_a(direction));
		EntityMinecart fillMinecart = Utils.getMinecartAt(field_145850_b, field_174879_c.func_177977_b(), 1f);
		if(drainTE instanceof IFluidHandler && fillMinecart instanceof IFluidHandler) {
			IFluidHandler toDrain = (IFluidHandler) drainTE;
			IFluidHandler toFill = (IFluidHandler) fillMinecart;

			// can we drain?
			FluidStack drained = toDrain.drain(direction, TRANSACTION_AMOUNT, false);
			if(drained != null) {
				// can we fill?
				int filled = toFill.fill(EnumFacing.UP, drained, false);
				if(filled > 0) {
					// drain the liquid and transfer it, buffer the amount for delay
					this.drained = toDrain.drain(direction, filled, true);
					this.isPouring = true;
					pour();

					// sync to clients
					if(!field_145850_b.field_72995_K && field_145850_b instanceof WorldServer) {
						TinkerNetwork.sendToClients((WorldServer)field_145850_b, field_174879_c, new FaucetActivationPacket(field_174879_c, drained));
					}

					return;
				}
			}
		}
		// draining unsuccessful
		reset();
	}

	@Override
	protected void pour() {
		if(drained == null) {
			return;
		}

		EntityMinecart fillMinecart = Utils.getMinecartAt(field_145850_b, field_174879_c.func_177977_b(), 1f);
		if(fillMinecart instanceof IFluidHandler)  {
			IFluidHandler toFill = (IFluidHandler) fillMinecart;

			FluidStack fillStack = drained.copy();
			fillStack.amount = Math.min(drained.amount, LIQUID_TRANSFER);

			// can we fill?
			int filled = toFill.fill(EnumFacing.UP, fillStack, false);
			if(filled > 0) {
				// transfer it
				this.drained.amount -= filled;
				fillStack.amount = filled;
				toFill.fill(EnumFacing.UP, fillStack, true);
			}
		}
		else {
			// filling TE got lost. reset. all liquid buffered is lost.
			reset();
		}
	}
}
