package xyz.brassgoggledcoders.moarcarts.recipes;

import net.minecraft.block.Block;
import net.minecraft.init.Items;
import net.minecraft.inventory.InventoryCrafting;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.item.crafting.ShapelessRecipes;
import net.minecraft.nbt.NBTTagCompound;

import java.util.ArrayList;
import java.util.List;

/**
 * @author SkySom
 */
public class NBTCartRecipe extends ShapelessRecipes
{
	protected ItemStack recipeOutput;
	protected ItemStack inputItem;

	public NBTCartRecipe(Item outputCartItem, Block cartBlock)
	{
		this(outputCartItem, cartBlock, 0);
	}

	public NBTCartRecipe(Item outputCartItem, Block cartBlock, int metadata)
	{
		this(new ItemStack(outputCartItem), new ItemStack(Item.func_150898_a(cartBlock), 1, metadata));
	}

	public NBTCartRecipe(Item outputCartItem, int itemMetadata, Block cartBlock, int metadata)
	{
		this(new ItemStack(outputCartItem, 1, itemMetadata), new ItemStack(Item.func_150898_a(cartBlock), 1, metadata));
	}

	public NBTCartRecipe(ItemStack outputCartItem, ItemStack cartBlock)
	{
		super(outputCartItem, getInputList(cartBlock));

		this.inputItem = cartBlock;
		this.recipeOutput = outputCartItem;
	}

	@Override
	public ItemStack func_77572_b(InventoryCrafting inventoryCrafting)
	{
		ItemStack output = this.recipeOutput.func_77946_l();
		for(int slot = 0; slot < inventoryCrafting.func_70302_i_(); slot++)
		{
			ItemStack currentSlotStack = inventoryCrafting.func_70301_a(slot);
			if(currentSlotStack != null && currentSlotStack.func_77973_b() != null)
			{
				if(inputItem != null && inputItem.func_77973_b() != null)
				{
					if(currentSlotStack.func_77973_b().equals(inputItem.func_77973_b()))
					{
						if(currentSlotStack.func_77942_o())
						{
							NBTTagCompound outputTagCompound;
							if(output.func_77942_o())
							{
								outputTagCompound = output.func_77978_p();
							} else
							{
								outputTagCompound = new NBTTagCompound();
							}
							outputTagCompound.func_74782_a("tilenbt", currentSlotStack.func_77978_p());
							output.func_77982_d(outputTagCompound);
						}
						if(currentSlotStack.func_82837_s())
						{
							output = output.func_151001_c(currentSlotStack.func_82833_r());
						}
					}
				}

			}

		}
		return output;
	}

	public static List<ItemStack> getInputList(ItemStack cartBlock)
	{
		List<ItemStack> list = new ArrayList<ItemStack>();
		list.add(cartBlock);
		list.add(new ItemStack(Items.field_151143_au));
		return list;
	}
}
